package org.polymodel.algebra.tom;

import static org.polymodel.algebra.tom.ArithmeticOperations.add;
import static org.polymodel.algebra.tom.ArithmeticOperations.sub;

import org.eclipse.emf.common.util.BasicEList;
import org.eclipse.emf.common.util.EList;
import org.polymodel.algebra.ComparisonOperator;
import org.polymodel.algebra.IntConstraint;
import org.polymodel.algebra.IntConstraintSystem;
import org.polymodel.algebra.IntExpression;
import org.polymodel.algebra.IntTerm;
import org.polymodel.algebra.Variable;
import org.polymodel.algebra.internal.AlgebraIntrospector;
import org.polymodel.algebra.polynomials.PolynomialExpression;
import org.polymodel.algebra.quasiAffine.QuasiAffineOperator;
import org.polymodel.algebra.reductions.ReductionOperator;

/**
 * Variable isolation tool.
 *   
 * @author antoine
 *   
 */
@SuppressWarnings("all")
public class RemoveRightSideTransformation{

	%include { sl.tom }

	%include { algebra_common.tom}   
	%include { algebra_terms.tom}    
	%include { algebra_all_ops.tom}      


	private static boolean DEBUG=false;

	private static void debug(String mess) {
		if(DEBUG) {
			System.out.println(mess);
		}
	}

	public static IntConstraint transform(IntConstraint expression) {
		try {
			return `OnceTopDown(RemoveRightSide()).visitLight(expression.copy(),new AlgebraIntrospector()); 
		} catch(Exception e) { 
			//e.printStackTrace(); 
			throw new RuntimeException("Visitor failure on "+expression, e);
		}
	}
 
	%strategy RemoveRightSide () extends Identity() {
		visit C {
			eq(l@_,r@_) -> {return `eq(sub(l,r),affine(terms(constant(0))));}
			ne(l@_,r@_) -> {return `ne(sub(l,r),affine(terms(constant(0))));}
			ge(l@_,r@_) -> {return `ge(sub(l,r),affine(terms(constant(0))));}
			gt(l@_,r@_) -> {return `ge(sub(l,add(r,1L)),affine(terms(constant(0L))));}
			le(l@_,r@_) -> {return `ge(sub(r,l),affine(terms(constant(0))));}
			lt(l@_,r@_) -> {return `ge(sub(r,add(l,1L)),affine(terms(constant(0L))));}
		} 
	}
}