package org.polymodel.algebra.tom;


import org.eclipse.emf.common.util.BasicEList;
import org.eclipse.emf.common.util.EList;
import org.polymodel.algebra.ComparisonOperator;
import org.polymodel.algebra.IntConstraint;
import org.polymodel.algebra.IntConstraintSystem;
import org.polymodel.algebra.IntExpression;
import org.polymodel.algebra.IntTerm;
import org.polymodel.algebra.Variable;
import org.polymodel.algebra.affine.AffineExpression;
import org.polymodel.algebra.affine.AffineTerm;
import org.polymodel.algebra.internal.AlgebraIntrospector;
import org.polymodel.algebra.polynomials.PolynomialExpression;
import org.polymodel.algebra.quasiAffine.QuasiAffineOperator;
import org.polymodel.algebra.reductions.ReductionOperator;

/**
 * Variable isolation tool.
 * 
 * @author antoine
 * 
 */
@SuppressWarnings("all")
public class Replace{

	%include { sl.tom }

	%include { algebra_common.tom}   
	%include { algebra_terms.tom}    
	%include { algebra_all_ops.tom}      

	/**
	 * Build an expression corresponding to a variable isolation. Variable is removed and
	 * other terms are negated. Input expression isn't modified.
	 * 
	 * @param expression 
	 * @param var variable to isolate
	 * @return a new expression
	 */
	static IntExpression newExpr;

	public static IntExpression replace(IntExpression expression, Variable var,IntExpression anewExpr) {
		try {
			newExpr= anewExpr;
			return `OnceTopDown(VariableReplacement(var)).visitLight(expression,new AlgebraIntrospector()); 
		} catch(Exception e) { 
			e.printStackTrace(); 
			throw new RuntimeException("Visitor failure on "+expression+ ":"+e.getMessage());
		}
	}

/*	public static EList<IntExpression> substitute(IntExpression expression, Variable var,IntExpression anewExpr) {
		try {
			newExpr= anewExpr;
			return `OnceTopDown(VariableExprReplacement(var)).visitLight(`EL(expression,anewExpr),new AlgebraIntrospector()); 
		} catch(Exception e) { 
			e.printStackTrace(); 
			throw new RuntimeException("Visitor failure on "+expression+ ":"+e.getMessage());
		} 
	}
*/

	%strategy VariableReplacement(var:V) extends Identity() {
		visit E {
			affine(terms(x1*,term(a,var),x3*)) 	-> { 				
				IntExpression newRes= newExpr.copy(); 
				return `sum(EL(
						affine(terms(x1*,x3*)),
						ArithmeticOperations.scale(newRes,a))).simplify();
			}  
		}  
	} 

/*	%strategy VariableExprReplacement(var:V) extends Identity() {
		visit EL {
			EL(initalExpr@affine(terms(x1*,term(a,var),x3*)),newExp) -> {
				IntExpression newRes= `newExpr.copy();

				%match(newExp) {
					affine(_*) -> {
						return `EL(sum(EL(
									affine(terms(x1*,x3*)),
									qaffine(terms(mul(newRes,a)))
								)).simplify());
					}
					qaffine(_*) -> {
					}
					sum(_*) -> {
						return `EL(sum(EL(
									affine(terms(x1*,x3*)),
									qaffine(terms(mul(newRes,a)))
								)).simplify());
					}
				}
				return `EL(sum(EL(
							affine(terms(x1*,x3*)),
							qaffine(terms(mul(newRes,a)))
						)));
			}
			EL(initalExpr@affine(terms(x1*,term(a,var),x3*)),newExp@affine(_*)) -> {
			}
	
		} 
	}
	*/
}