package org.polymodel.x10p.util

import org.polymodel.x10p.Loop
import org.polymodel.x10p.Statement
import org.polymodel.x10p.StatementBlock

import static extension org.polymodel.x10p.util.XtendUnparserUtils.*
import org.polymodel.x10p.Assignment
import org.polymodel.x10p.ArrayAccess
import org.polymodel.x10p.Async
import org.polymodel.x10p.Finish

class XtendX10pStatementUnparser {
	
	def dispatch CharSequence unparse(Statement stmt) {
		'''//TODO unhandled statement type'''
	}
	
	def dispatch CharSequence unparse(Loop loop) '''
		for («loop.iterator»=«loop.LB.print»:«loop.UB.print») «IF loop.statement instanceof StatementBlock»«loop.statement.unparse»«ENDIF»
			«IF !(loop.statement instanceof StatementBlock)»«loop.statement.unparse»«ENDIF»
	'''
	
//	def dispatch unparse(Loop loop) '''
//		for («loop.iterator»=«loop.LB»:«loop.UB»; «loop.step») «IF loop.statement instanceof StatementBlock»«loop.statement.unparse»«ENDIF»
//			«IF !(loop.statement instanceof StatementBlock)»«loop.statement.unparse»«ENDIF»
//	'''
	
	def dispatch CharSequence unparse(StatementBlock block) '''
		{
			«block.statements.join('\n', [s|s.unparse])»
		}
	'''
	
	def dispatch CharSequence unparse(Assignment a) '''
		«a.write.print» = «a.name»(«a.reads.join(', ', [r|r.print])»);
	'''
	
	def dispatch CharSequence unparse(Async a) {
		'''async «a.statement.unparse»'''
	}
	
	def dispatch CharSequence unparse(Finish f) {
		'''finish «f.statement.unparse»'''
	}
	
	def print(ArrayAccess a) {
		'''«a.array.name»«a.accesses.join('[', '][', ']', [e|e.print])»'''
	}
}