package org.polymodel.x10p.util

import org.polymodel.x10p.Program
import org.polymodel.x10p.Array
import com.google.inject.Inject

import static extension org.polymodel.x10p.util.XtendUnparserUtils.*;

class XtendX10pUnparser {
	
	@Inject extension XtendX10pStatementUnparser stmtUnparser;

	def unparse(Program p) '''
		Program «p.parameterList» {
			«p.variables.join('\n', [v|v.varDecl])»
			
			«IF p.statement != null»«p.statement.unparse»«ENDIF»
		}
	'''
	
	def parameterList(Program p) {
		return p.parameters.join('[', ',', ']', [e|e.toString])
	}
	
	def CharSequence varDecl(Array a) {
		'''var «a.name»«a.dimensions.join('[', '][', ']', [e|e.print])»'''
	}
	
}